class Oxen::PrintserversController < AbstractResourcesController
  skip_before_filter :authenticate_user!, only: :port

  def port
    authorize Printserver.new
    unless params[:mac].blank?
      port = Printserver.find_by_mac_addr(params[:mac])
      if !port
        port = 'port not found!'
      else
        port = port.active ? port.port : 'printserver er ikke aktiv!'
      end
      render plain: port
    end
  end

  private

    def set_fab_button_options

      opt = { items: {}}
      case params[:action]
      when 'edit','update';    opt[:items].merge! list: { ajax: 'get', icon: 'list', class: 'blue', url: "/admin/accounts/#{resource.account.id}" }
      when 'show';             opt[:items].merge! list: { ajax: 'get', icon: 'list', class: 'blue', url: "/admin/accounts/#{resource.account.id}" }
      # when 'index';            opt[:items].merge! list: { ajax: 'get', icon: 'list', class: 'blue', url: "/admin/accounts/#{resource.account.id}" }
      end

      @fab_button_options = opt
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def resource_params
      params[:printserver][:mac_addr] = params[:printserver][:mac_addr].strip.gsub( / /, ':') rescue ''
      params[:printserver][:account_id] = current_user.admin? ? (params[:parent_id] || params[:printserver][:account_id]) : current_user.account.id
      params.require(:printserver).permit(:parent, :parent_id, :account_id, :location, :lokation, :mac_addr, :port, :active)
    end


end
