class PrinterMailer < ActionMailer::Base
  layout 'mailer'

  def send_print usr, file, msg=nil, subj=nil
    @usr = usr
    fname = case file
    when /\/pdf.*$/; 'print%s.pdf' % DateTime.now.nsec
    else 'print%s.label' % DateTime.now.nsec
    end
    attachments[fname] = File.read(file) unless file.blank?
    @logo = @usr.account.logos.first.image.url rescue ""
    attachments.inline['logo.png'] = File.read( File.join(Rails.root,'public',@logo)) unless @logo.blank?

    @msg = msg || "See attached PDF"
    subj ||= "Kontakt administrator! Der mangler en printer definition!"

    mail  from: 'no-reply@wheelstore.space',
          to: @usr.email,
          subject: subj
  end
end
